//
//  CocoaDragView.mm
//  DragBug
//
//  Created by Mike Pinkerton on Mon Feb 16 2004.
//  Copyright (c) 2004 __MyCompanyName__. All rights reserved.
//

#import "CocoaDragView.h"

static const NSString* kCorePasteboardFlavorType_url  = @"CorePasteboardFlavorType 0x75726C20"; // 'url '  url
static const NSString* kCorePasteboardFlavorType_urln = @"CorePasteboardFlavorType 0x75726C6E"; // 'urln'  title

@interface CocoaDragView(PRIV)
- (void)setDataForURL:(NSString*)url title:(NSString*)title pboard:(NSPasteboard*)pboard;
@end

@implementation CocoaDragView

- (id)initWithFrame:(NSRect)frame {
    self = [super initWithFrame:frame];
    if (self) {
        // Initialization code here.
    }
    return self;
}

- (void)drawRect:(NSRect)rect 
{
    [[NSColor redColor] set];
    [NSBezierPath fillRect:rect];
}

- (void)mouseDragged:(NSEvent *)theEvent
{
  NSPasteboard *pboard = [NSPasteboard pasteboardWithName:NSDragPboard];

  NSArray* allTypes = [NSArray arrayWithObjects:
                                  NSURLPboardType,
                                  NSStringPboardType,
                                  kCorePasteboardFlavorType_url,
                                  kCorePasteboardFlavorType_urln,
                                  nil];
	[pboard declareTypes:allTypes owner:self];

  [self setDataForURL:@"http://www.mozilla.org" title:@"Mozilla.org" pboard:pboard];
  
  [self dragImage:[NSImage imageNamed:@"NSApplicationIcon"] at: NSMakePoint(0,0) offset: NSMakeSize(0,0)
            event: theEvent pasteboard: pboard source: self slideBack: YES];
}

- (unsigned int)draggingSourceOperationMaskForLocal:(BOOL)flag
{
  return NSDragOperationGeneric;
}


- (void)setDataForURL:(NSString*)url title:(NSString*)title pboard:(NSPasteboard*)pboard
{
  NSDictionary *data = [NSDictionary dictionaryWithObjectsAndKeys:
                            url, @"url",
                            title, @"title",
                            nil];

  [pboard setPropertyList:data forType: @"MozURLType"];
  [[NSURL URLWithString:url] writeToPasteboard: pboard];
  [pboard setString:url forType: NSStringPboardType];

  const char* tempCString = [url UTF8String];
  [pboard setData:[NSData dataWithBytes:tempCString length:strlen(tempCString)] forType: kCorePasteboardFlavorType_url];

  tempCString = [title UTF8String];
  [pboard setData:[NSData dataWithBytes:tempCString length:strlen(tempCString)] forType: kCorePasteboardFlavorType_urln];
}

@end
